'use strict';

var path = require('path');

module.exports = function (grunt) {

  grunt.loadNpmTasks('grunt-bower-task');
  grunt.loadNpmTasks('grunt-contrib-less');
  grunt.loadNpmTasks('grunt-contrib-uglify');
  grunt.loadNpmTasks('grunt-contrib-watch');
  grunt.loadNpmTasks('grunt-shell');

  grunt.initConfig({

    appDir: path.join(path.dirname(__dirname)),
    bowerDir: path.join(path.join(path.dirname(__dirname)), 'grunt', 'lib'),
    grunt_dir: path.join(path.join(path.dirname(__dirname)), 'grunt'),
    jsDir: path.join(path.join(path.dirname(__dirname)), 'js'),
    lessDir: path.join(path.join(path.dirname(__dirname)), 'less'),

    watch: {
      options: {
        livereload: true
      },
      html: {
        files: ['<%= appDir %>/aws_security_groups.html']
      },
      js: {
        files: [
          '<%= jsDir %>/*.js',
          '<%= jsDir %>/directives/*.js'
        ],
        tasks: ['shell', 'uglify']
      }
    },

    shell: {
      runMake: {
        command: 'cd <%= bowerDir %>/sigma; make concat'
      }
    },

    uglify: {
      'aws_security_groups': {
        options: {
          beautify: true,
          mangle: false,
          bracketize: true
        },
        files: {
          '<%= jsDir %>/generated/aws_security_groups.js': [
            '<%= bowerDir %>/sigma/build/sigma.concat.js',
            '<%= jsDir %>/app.js',
            '<%= jsDir %>/directives/sigma.js'
          ]
        }
      }
    },

    bower: {
      install: true
    }

  });

  grunt.registerTask('default', ['watch']);
};
