var sigma = {};

sigma.tools = {}, sigma.classes = {}, sigma.instances = {}, function() {
    Array.prototype.some || (Array.prototype.some = function(fun) {
        var len = this.length;
        if ("function" != typeof fun) throw new TypeError();
        for (var thisp = arguments[1], i = 0; len > i; i++) if (i in this && fun.call(thisp, this[i], i, this)) return !0;
        return !1;
    }), Array.prototype.forEach || (Array.prototype.forEach = function(fun) {
        var len = this.length;
        if ("function" != typeof fun) throw new TypeError();
        for (var thisp = arguments[1], i = 0; len > i; i++) i in this && fun.call(thisp, this[i], i, this);
    }), Array.prototype.map || (Array.prototype.map = function(fun) {
        var len = this.length;
        if ("function" != typeof fun) throw new TypeError();
        for (var res = new Array(len), thisp = arguments[1], i = 0; len > i; i++) i in this && (res[i] = fun.call(thisp, this[i], i, this));
        return res;
    }), Array.prototype.filter || (Array.prototype.filter = function(fun) {
        var len = this.length;
        if ("function" != typeof fun) throw new TypeError();
        for (var res = new Array(), thisp = arguments[1], i = 0; len > i; i++) if (i in this) {
            var val = this[i];
            fun.call(thisp, val, i, this) && res.push(val);
        }
        return res;
    }), Object.keys || (Object.keys = function() {
        var hasOwnProperty = Object.prototype.hasOwnProperty, hasDontEnumBug = !{
            toString: null
        }.propertyIsEnumerable("toString"), dontEnums = [ "toString", "toLocaleString", "valueOf", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "constructor" ], dontEnumsLength = dontEnums.length;
        return function(obj) {
            if ("object" != typeof obj && "function" != typeof obj || null === obj) throw new TypeError("Object.keys called on non-object");
            var result = [];
            for (var prop in obj) hasOwnProperty.call(obj, prop) && result.push(prop);
            if (hasDontEnumBug) for (var i = 0; dontEnumsLength > i; i++) hasOwnProperty.call(obj, dontEnums[i]) && result.push(dontEnums[i]);
            return result;
        };
    }());
}(), sigma.classes.Cascade = function() {
    this.p = {}, this.config = function(a1, a2) {
        if ("string" == typeof a1 && void 0 == a2) return this.p[a1];
        var o = "object" == typeof a1 && void 0 == a2 ? a1 : {};
        "string" == typeof a1 && (o[a1] = a2);
        for (var k in o) void 0 != this.p[k] && (this.p[k] = o[k]);
        return this;
    };
}, sigma.classes.EventDispatcher = function() {
    function one(events, handler) {
        if (!handler || !events) return _self;
        var eArray = "string" == typeof events ? events.split(" ") : events;
        return eArray.forEach(function(event) {
            _h[event] || (_h[event] = []), _h[event].push({
                h: handler,
                one: !0
            });
        }), _self;
    }
    function bind(events, handler) {
        if (!handler || !events) return _self;
        var eArray = "string" == typeof events ? events.split(" ") : events;
        return eArray.forEach(function(event) {
            _h[event] || (_h[event] = []), _h[event].push({
                h: handler,
                one: !1
            });
        }), _self;
    }
    function unbind(events, handler) {
        events || (_h = {});
        var eArray = "string" == typeof events ? events.split(" ") : events;
        return handler ? eArray.forEach(function(event) {
            _h[event] && (_h[event] = _h[event].filter(function(e) {
                return e.h != handler;
            })), _h[event] && 0 == _h[event].length && delete _h[event];
        }) : eArray.forEach(function(event) {
            delete _h[event];
        }), _self;
    }
    function dispatch(type, content) {
        return _h[type] && (_h[type].forEach(function(e) {
            e.h({
                type: type,
                content: content,
                target: _self
            });
        }), _h[type] = _h[type].filter(function(e) {
            return !e.one;
        })), _self;
    }
    var _h = {}, _self = this;
    this.one = one, this.bind = bind, this.unbind = unbind, this.dispatch = dispatch;
}, function() {
    function Graph() {
        function addNode(id, params) {
            if (self.nodesIndex[id]) throw new Error('Node "' + id + '" already exists.');
            params = params || {};
            var n = {
                x: 0,
                y: 0,
                size: 1,
                degree: 0,
                inDegree: 0,
                outDegree: 0,
                fixed: !1,
                active: !1,
                hidden: !1,
                forceLabel: !1,
                label: id.toString(),
                id: id.toString(),
                attr: {}
            };
            for (var k in params) switch (k) {
              case "id":
                break;

              case "x":
              case "y":
              case "size":
                n[k] = +params[k];
                break;

              case "fixed":
              case "active":
              case "hidden":
              case "forceLabel":
                n[k] = !!params[k];
                break;

              case "color":
              case "label":
                n[k] = params[k];
                break;

              default:
                n.attr[k] = params[k];
            }
            return self.nodes.push(n), self.nodesIndex[id.toString()] = n, self;
        }
        function cloneNode(node) {
            return {
                x: node.x,
                y: node.y,
                size: node.size,
                degree: node.degree,
                inDegree: node.inDegree,
                outDegree: node.outDegree,
                displayX: node.displayX,
                displayY: node.displayY,
                displaySize: node.displaySize,
                label: node.label,
                id: node.id,
                color: node.color,
                fixed: node.fixed,
                active: node.active,
                hidden: node.hidden,
                forceLabel: node.forceLabel,
                attr: node.attr
            };
        }
        function checkNode(node, copy) {
            for (var k in copy) switch (k) {
              case "id":
              case "attr":
              case "degree":
              case "inDegree":
              case "outDegree":
              case "displayX":
              case "displayY":
              case "displaySize":
                break;

              case "x":
              case "y":
              case "size":
                node[k] = +copy[k];
                break;

              case "fixed":
              case "active":
              case "hidden":
              case "forceLabel":
                node[k] = !!copy[k];
                break;

              case "color":
              case "label":
                node[k] = (copy[k] || "").toString();
                break;

              default:
                node.attr[k] = copy[k];
            }
            return self;
        }
        function dropNode(v) {
            var a = (v instanceof Array ? v : [ v ]) || [];
            return a.forEach(function(id) {
                if (self.nodesIndex[id]) {
                    var index = null;
                    self.nodes.some(function(n, i) {
                        return n.id == id ? (index = i, !0) : !1;
                    }), null != index && self.nodes.splice(index, 1), delete self.nodesIndex[id], self.edges = self.edges.filter(function(e) {
                        return e.source.id == id ? (delete self.edgesIndex[e.id], e.target.degree--, e.target.inDegree--, 
                        !1) : e.target.id == id ? (delete self.edgesIndex[e.id], e.source.degree--, e.source.outDegree--, 
                        !1) : !0;
                    });
                } else sigma.log('Node "' + id + '" does not exist.');
            }), self;
        }
        function addEdge(id, source, target, params) {
            if (self.edgesIndex[id]) throw new Error('Edge "' + id + '" already exists.');
            if (!self.nodesIndex[source]) {
                var s = "Edge's source \"" + source + '" does not exist yet.';
                throw new Error(s);
            }
            if (!self.nodesIndex[target]) {
                var s = "Edge's target \"" + target + '" does not exist yet.';
                throw new Error(s);
            }
            params = params || {};
            var e = {
                source: self.nodesIndex[source],
                target: self.nodesIndex[target],
                size: 1,
                weight: 1,
                displaySize: .5,
                label: id.toString(),
                id: id.toString(),
                hidden: !1,
                attr: {}
            };
            e.source.degree++, e.source.outDegree++, e.target.degree++, e.target.inDegree++;
            for (var k in params) switch (k) {
              case "id":
              case "source":
              case "target":
                break;

              case "hidden":
                e[k] = !!params[k];
                break;

              case "size":
              case "weight":
                e[k] = +params[k];
                break;

              case "color":
                e[k] = params[k].toString();
                break;

              case "type":
                e[k] = params[k].toString();
                break;

              case "label":
                e[k] = params[k];
                break;

              default:
                e.attr[k] = params[k];
            }
            return self.edges.push(e), self.edgesIndex[id.toString()] = e, self;
        }
        function cloneEdge(edge) {
            return {
                source: edge.source.id,
                target: edge.target.id,
                size: edge.size,
                type: edge.type,
                weight: edge.weight,
                displaySize: edge.displaySize,
                label: edge.label,
                hidden: edge.hidden,
                id: edge.id,
                attr: edge.attr,
                color: edge.color
            };
        }
        function checkEdge(edge, copy) {
            for (var k in copy) switch (k) {
              case "id":
              case "displaySize":
                break;

              case "weight":
              case "size":
                edge[k] = +copy[k];
                break;

              case "source":
              case "target":
                edge[k] = self.nodesIndex[k] || edge[k];
                break;

              case "hidden":
                edge[k] = !!copy[k];
                break;

              case "color":
              case "label":
              case "type":
                edge[k] = (copy[k] || "").toString();
                break;

              default:
                edge.attr[k] = copy[k];
            }
            return self;
        }
        function dropEdge(v) {
            var a = (v instanceof Array ? v : [ v ]) || [];
            return a.forEach(function(id) {
                if (self.edgesIndex[id]) {
                    self.edgesIndex[id].source.degree--, self.edgesIndex[id].source.outDegree--, self.edgesIndex[id].target.degree--, 
                    self.edgesIndex[id].target.inDegree--;
                    var index = null;
                    self.edges.some(function(n, i) {
                        return n.id == id ? (index = i, !0) : !1;
                    }), null != index && self.edges.splice(index, 1), delete self.edgesIndex[id];
                } else sigma.log('Edge "' + id + '" does not exist.');
            }), self;
        }
        function empty() {
            return self.nodes = [], self.nodesIndex = {}, self.edges = [], self.edgesIndex = {}, 
            self;
        }
        function rescale(w, h, parseNodes, parseEdges) {
            var weightMax = 0, sizeMax = 0;
            parseNodes && self.nodes.forEach(function(node) {
                sizeMax = Math.max(node.size, sizeMax);
            }), parseEdges && self.edges.forEach(function(edge) {
                weightMax = Math.max(edge.size, weightMax);
            }), sizeMax = sizeMax || 1, weightMax = weightMax || 1;
            var xMin, xMax, yMin, yMax;
            parseNodes && self.nodes.forEach(function(node) {
                xMax = Math.max(node.x, xMax || node.x), xMin = Math.min(node.x, xMin || node.x), 
                yMax = Math.max(node.y, yMax || node.y), yMin = Math.min(node.y, yMin || node.y);
            });
            var scale = "outside" == self.p.scalingMode ? Math.max(w / Math.max(xMax - xMin, 1), h / Math.max(yMax - yMin, 1)) : Math.min(w / Math.max(xMax - xMin, 1), h / Math.max(yMax - yMin, 1)), margin = (self.p.maxNodeSize || sizeMax) / scale;
            xMax += margin, xMin -= margin, yMax += margin, yMin -= margin, scale = "outside" == self.p.scalingMode ? Math.max(w / Math.max(xMax - xMin, 1), h / Math.max(yMax - yMin, 1)) : Math.min(w / Math.max(xMax - xMin, 1), h / Math.max(yMax - yMin, 1));
            var a, b;
            self.p.maxNodeSize || self.p.minNodeSize ? self.p.maxNodeSize == self.p.minNodeSize ? (a = 0, 
            b = self.p.maxNodeSize) : (a = (self.p.maxNodeSize - self.p.minNodeSize) / sizeMax, 
            b = self.p.minNodeSize) : (a = 1, b = 0);
            var c, d;
            return self.p.maxEdgeSize || self.p.minEdgeSize ? self.p.maxEdgeSize == self.p.minEdgeSize ? (c = 0, 
            d = self.p.minEdgeSize) : (c = (self.p.maxEdgeSize - self.p.minEdgeSize) / weightMax, 
            d = self.p.minEdgeSize) : (c = 1, d = 0), parseNodes && self.nodes.forEach(function(node) {
                node.displaySize = node.size * a + b, node.fixed || (node.displayX = (node.x - (xMax + xMin) / 2) * scale + w / 2, 
                node.displayY = (node.y - (yMax + yMin) / 2) * scale + h / 2);
            }), parseEdges && self.edges.forEach(function(edge) {
                edge.displaySize = edge.size * c + d;
            }), self;
        }
        function translate(sceneX, sceneY, ratio, parseNodes, parseEdges) {
            var sizeRatio = Math.pow(ratio, self.p.nodesPowRatio);
            return parseNodes && self.nodes.forEach(function(node) {
                node.fixed || (node.displayX = node.displayX * ratio + sceneX, node.displayY = node.displayY * ratio + sceneY), 
                node.displaySize = node.displaySize * sizeRatio;
            }), sizeRatio = Math.pow(ratio, self.p.edgesPowRatio), parseEdges && self.edges.forEach(function(edge) {
                edge.displaySize = edge.displaySize * sizeRatio;
            }), self;
        }
        function setBorders() {
            self.borders = {}, self.nodes.forEach(function(node) {
                self.borders.minX = Math.min(void 0 == self.borders.minX ? node.displayX - node.displaySize : self.borders.minX, node.displayX - node.displaySize), 
                self.borders.maxX = Math.max(void 0 == self.borders.maxX ? node.displayX + node.displaySize : self.borders.maxX, node.displayX + node.displaySize), 
                self.borders.minY = Math.min(void 0 == self.borders.minY ? node.displayY - node.displaySize : self.borders.minY, node.displayY - node.displaySize), 
                self.borders.maxY = Math.max(void 0 == self.borders.maxY ? node.displayY - node.displaySize : self.borders.maxY, node.displayY - node.displaySize);
            });
        }
        function checkHover(mX, mY) {
            var dX, dY, s, over = [], out = [];
            return self.nodes.forEach(function(node) {
                if (node.hidden) return node.hover = !1, void 0;
                dX = Math.abs(node.displayX - mX), dY = Math.abs(node.displayY - mY), s = node.displaySize;
                var oldH = node.hover, newH = s > dX && s > dY && Math.sqrt(dX * dX + dY * dY) < s;
                oldH && !newH ? (node.hover = !1, out.push(node.id)) : newH && !oldH && (node.hover = !0, 
                over.push(node.id));
            }), over.length && self.dispatch("overnodes", over), out.length && self.dispatch("outnodes", out), 
            self;
        }
        function iterNodes(fun, ids) {
            var a = ids ? ids.map(function(id) {
                return self.nodesIndex[id];
            }) : self.nodes, aCopies = a.map(cloneNode);
            return aCopies.forEach(fun), a.forEach(function(n, i) {
                checkNode(n, aCopies[i]);
            }), self;
        }
        function iterEdges(fun, ids) {
            var a = ids ? ids.map(function(id) {
                return self.edgesIndex[id];
            }) : self.edges, aCopies = a.map(cloneEdge);
            return aCopies.forEach(fun), a.forEach(function(e, i) {
                checkEdge(e, aCopies[i]);
            }), self;
        }
        function getNodes(ids) {
            var a = ((ids instanceof Array ? ids : [ ids ]) || []).map(function(id) {
                return cloneNode(self.nodesIndex[id]);
            });
            return ids instanceof Array ? a : a[0];
        }
        function getEdges(ids) {
            var a = ((ids instanceof Array ? ids : [ ids ]) || []).map(function(id) {
                return cloneEdge(self.edgesIndex[id]);
            });
            return ids instanceof Array ? a : a[0];
        }
        sigma.classes.Cascade.call(this), sigma.classes.EventDispatcher.call(this);
        var self = this;
        this.p = {
            minNodeSize: 0,
            maxNodeSize: 0,
            minEdgeSize: 0,
            maxEdgeSize: 0,
            scalingMode: "inside",
            nodesPowRatio: .5,
            edgesPowRatio: 0
        }, this.borders = {}, empty(), this.addNode = addNode, this.addEdge = addEdge, this.dropNode = dropNode, 
        this.dropEdge = dropEdge, this.iterEdges = iterEdges, this.iterNodes = iterNodes, 
        this.getEdges = getEdges, this.getNodes = getNodes, this.empty = empty, this.rescale = rescale, 
        this.translate = translate, this.setBorders = setBorders, this.checkHover = checkHover;
    }
    function Monitor(instance, dom) {
        function activate() {
            return self.monitoring || (self.monitoring = window.setInterval(routine, 1e3 / self.p.fps)), 
            self;
        }
        function desactivate() {
            return self.monitoring && (window.clearInterval(self.monitoring), self.monitoring = null, 
            self.p.dom.innerHTML = ""), self;
        }
        function routine() {
            var s = "";
            s += "<p>GLOBAL :</p>";
            for (var k in self.p.globalProbes) s += "<p>" + k + " : " + self.p.globalProbes[k]() + "</p>";
            s += "<br><p>LOCAL :</p>";
            for (var k in self.p.localProbes) s += "<p>" + k + " : " + self.p.localProbes[k]() + "</p>";
            return self.p.dom.innerHTML = s, self;
        }
        sigma.classes.Cascade.call(this);
        var self = this;
        this.instance = instance, this.monitoring = !1, this.p = {
            fps: 40,
            dom: dom,
            globalProbes: {
                "Time (ms)": sigma.chronos.getExecutionTime,
                Queue: sigma.chronos.getQueuedTasksCount,
                Tasks: sigma.chronos.getTasksCount,
                FPS: sigma.chronos.getFPS
            },
            localProbes: {
                "Nodes count": function() {
                    return self.instance.graph.nodes.length;
                },
                "Edges count": function() {
                    return self.instance.graph.edges.length;
                }
            }
        }, this.activate = activate, this.desactivate = desactivate;
    }
    function MouseCaptor(dom) {
        function getX(e) {
            return void 0 != e.offsetX && e.offsetX || void 0 != e.layerX && e.layerX || void 0 != e.clientX && e.clientX;
        }
        function getY(e) {
            return void 0 != e.offsetY && e.offsetY || void 0 != e.layerY && e.layerY || void 0 != e.clientY && e.clientY;
        }
        function getDelta(e) {
            return void 0 != e.wheelDelta && e.wheelDelta || void 0 != e.detail && -e.detail;
        }
        function moveHandler(event) {
            oldMouseX = self.mouseX, oldMouseY = self.mouseY, self.mouseX = getX(event), self.mouseY = getY(event), 
            self.isMouseDown && drag(event), self.dispatch("move"), event.preventDefault ? event.preventDefault() : event.returnValue = !1;
        }
        function upHandler(event) {
            self.p.mouseEnabled && self.isMouseDown && (self.isMouseDown = !1, self.dispatch("mouseup"), 
            stopDrag(), event.preventDefault ? event.preventDefault() : event.returnValue = !1);
        }
        function downHandler(event) {
            self.p.mouseEnabled && (self.isMouseDown = !0, oldMouseX = self.mouseX, oldMouseY = self.mouseY, 
            self.dispatch("mousedown"), startDrag(), event.preventDefault ? event.preventDefault() : event.returnValue = !1);
        }
        function wheelHandler(event) {
            self.p.mouseEnabled && (startInterpolate(self.mouseX, self.mouseY, self.ratio * (getDelta(event) > 0 ? self.p.zoomMultiply : 1 / self.p.zoomMultiply)), 
            self.p.blockScroll && (event.preventDefault ? event.preventDefault() : event.returnValue = !1));
        }
        function startDrag() {
            oldStageX = self.stageX, oldStageY = self.stageY, startX = self.mouseX, startY = self.mouseY, 
            lastStageX = self.stageX, lastStageX2 = self.stageX, lastStageY = self.stageY, lastStageY2 = self.stageY, 
            self.dispatch("startdrag");
        }
        function stopDrag() {
            (oldStageX != self.stageX || oldStageY != self.stageY) && startInterpolate(self.stageX + self.p.inertia * (self.stageX - lastStageX2), self.stageY + self.p.inertia * (self.stageY - lastStageY2));
        }
        function drag() {
            var newStageX = self.mouseX - startX + oldStageX, newStageY = self.mouseY - startY + oldStageY;
            (newStageX != self.stageX || newStageY != self.stageY) && (lastStageX2 = lastStageX, 
            lastStageY2 = lastStageY, lastStageX = newStageX, lastStageY = newStageY, self.stageX = newStageX, 
            self.stageY = newStageY, self.dispatch("drag"));
        }
        function startInterpolate(x, y, ratio) {
            self.isMouseDown || (window.clearInterval(self.interpolationID), isZooming = void 0 != ratio, 
            oldStageX = self.stageX, targetStageX = x, oldStageY = self.stageY, targetStageY = y, 
            oldRatio = self.ratio, targetRatio = ratio || self.ratio, targetRatio = Math.min(Math.max(targetRatio, self.p.minRatio), self.p.maxRatio), 
            progress = self.p.directZooming ? 1 - (isZooming ? self.p.zoomDelta : self.p.dragDelta) : 0, 
            (self.ratio != targetRatio || self.stageX != targetStageX || self.stageY != targetStageY) && (interpolate(), 
            self.interpolationID = window.setInterval(interpolate, 50), self.dispatch("startinterpolate")));
        }
        function stopInterpolate() {
            var oldRatio = self.ratio;
            isZooming ? (self.ratio = targetRatio, self.stageX = targetStageX + (self.stageX - targetStageX) * self.ratio / oldRatio, 
            self.stageY = targetStageY + (self.stageY - targetStageY) * self.ratio / oldRatio) : (self.stageX = targetStageX, 
            self.stageY = targetStageY), self.dispatch("stopinterpolate");
        }
        function interpolate() {
            progress += isZooming ? self.p.zoomDelta : self.p.dragDelta, progress = Math.min(progress, 1);
            var k = sigma.easing.quadratic.easeout(progress), oldRatio = self.ratio;
            self.ratio = oldRatio * (1 - k) + targetRatio * k, isZooming ? (self.stageX = targetStageX + (self.stageX - targetStageX) * self.ratio / oldRatio, 
            self.stageY = targetStageY + (self.stageY - targetStageY) * self.ratio / oldRatio) : (self.stageX = oldStageX * (1 - k) + targetStageX * k, 
            self.stageY = oldStageY * (1 - k) + targetStageY * k), self.dispatch("interpolate"), 
            progress >= 1 && (window.clearInterval(self.interpolationID), stopInterpolate());
        }
        function checkBorders() {
            return self;
        }
        sigma.classes.Cascade.call(this), sigma.classes.EventDispatcher.call(this);
        var self = this, dom = dom;
        this.p = {
            minRatio: 1,
            maxRatio: 32,
            marginRatio: 1,
            zoomDelta: .1,
            dragDelta: .3,
            zoomMultiply: 2,
            directZooming: !1,
            blockScroll: !0,
            inertia: 1.1,
            mouseEnabled: !0
        };
        var oldMouseX = 0, oldMouseY = 0, startX = 0, startY = 0, oldStageX = 0, oldStageY = 0, oldRatio = 1, targetRatio = 1, targetStageX = 0, targetStageY = 0, lastStageX = 0, lastStageX2 = 0, lastStageY = 0, lastStageY2 = 0, progress = 0, isZooming = !1;
        this.stageX = 0, this.stageY = 0, this.ratio = 1, this.mouseX = 0, this.mouseY = 0, 
        this.isMouseDown = !1, dom.addEventListener("DOMMouseScroll", wheelHandler, !0), 
        dom.addEventListener("mousewheel", wheelHandler, !0), dom.addEventListener("mousemove", moveHandler, !0), 
        dom.addEventListener("mousedown", downHandler, !0), document.addEventListener("mouseup", upHandler, !0), 
        this.checkBorders = checkBorders, this.interpolate = startInterpolate;
    }
    function Plotter(nodesCtx, edgesCtx, labelsCtx, hoverCtx, graph, w, h) {
        function task_drawEdge() {
            for (var s, t, c = graph.edges.length, i = 0; i++ < self.p.edgesSpeed && self.currentEdgeIndex < c; ) e = graph.edges[self.currentEdgeIndex], 
            s = e.source, t = e.target, e.hidden || s.hidden || t.hidden || !self.isOnScreen(s) && !self.isOnScreen(t) ? self.currentEdgeIndex++ : drawEdge(graph.edges[self.currentEdgeIndex++]);
            return self.currentEdgeIndex < c;
        }
        function task_drawNode() {
            for (var c = graph.nodes.length, i = 0; i++ < self.p.nodesSpeed && self.currentNodeIndex < c; ) self.isOnScreen(graph.nodes[self.currentNodeIndex]) ? drawNode(graph.nodes[self.currentNodeIndex++]) : self.currentNodeIndex++;
            return self.currentNodeIndex < c;
        }
        function task_drawLabel() {
            for (var c = graph.nodes.length, i = 0; i++ < self.p.labelsSpeed && self.currentLabelIndex < c; ) self.isOnScreen(graph.nodes[self.currentLabelIndex]) ? drawLabel(graph.nodes[self.currentLabelIndex++]) : self.currentLabelIndex++;
            return self.currentLabelIndex < c;
        }
        function drawNode(node) {
            var size = Math.round(10 * node.displaySize) / 10, ctx = nodesCtx;
            return ctx.fillStyle = node.color, ctx.beginPath(), ctx.arc(node.displayX, node.displayY, size, 0, 2 * Math.PI, !0), 
            ctx.closePath(), ctx.fill(), node.hover && drawHoverNode(node), self;
        }
        function drawEdge(edge) {
            var x1 = edge.source.displayX, y1 = edge.source.displayY, x2 = edge.target.displayX, y2 = edge.target.displayY, color = edge.color;
            if (!color) switch (self.p.edgeColor) {
              case "source":
                color = edge.source.color || self.p.defaultNodeColor;
                break;

              case "target":
                color = edge.target.color || self.p.defaultNodeColor;
                break;

              default:
                color = self.p.defaultEdgeColor;
            }
            var ctx = edgesCtx;
            switch (edge.type || self.p.defaultEdgeType) {
              case "curve":
                ctx.strokeStyle = color, ctx.lineWidth = edge.displaySize / 3, ctx.beginPath(), 
                ctx.moveTo(x1, y1), ctx.quadraticCurveTo((x1 + x2) / 2 + (y2 - y1) / 4, (y1 + y2) / 2 + (x1 - x2) / 4, x2, y2), 
                ctx.stroke();
                break;

              case "line":
              default:
                ctx.strokeStyle = color, ctx.lineWidth = edge.displaySize / 3, ctx.beginPath(), 
                ctx.moveTo(x1, y1), ctx.lineTo(x2, y2), ctx.stroke();
            }
            return self;
        }
        function drawLabel(node) {
            var ctx = labelsCtx;
            if (node.displaySize >= self.p.labelThreshold || node.forceLabel) {
                var fontSize = "fixed" == self.p.labelSize ? self.p.defaultLabelSize : self.p.labelSizeRatio * node.displaySize;
                ctx.font = self.p.fontStyle + fontSize + "px " + self.p.font, ctx.fillStyle = "node" == self.p.labelColor ? node.color || self.p.defaultNodeColor : self.p.defaultLabelColor, 
                ctx.fillText(node.label, Math.round(node.displayX + 1.5 * node.displaySize), Math.round(node.displayY + fontSize / 2 - 3));
            }
            return self;
        }
        function drawHoverNode(node) {
            var ctx = hoverCtx, fontSize = "fixed" == self.p.labelSize ? self.p.defaultLabelSize : self.p.labelSizeRatio * node.displaySize;
            return ctx.font = (self.p.hoverFontStyle || self.p.fontStyle || "") + " " + fontSize + "px " + (self.p.hoverFont || self.p.font || ""), 
            ctx.fillStyle = "node" == self.p.labelHoverBGColor ? node.color || self.p.defaultNodeColor : self.p.defaultHoverLabelBGColor, 
            ctx.beginPath(), self.p.labelHoverShadow && (ctx.shadowOffsetX = 0, ctx.shadowOffsetY = 0, 
            ctx.shadowBlur = 4, ctx.shadowColor = self.p.labelHoverShadowColor), sigma.tools.drawRoundRect(ctx, Math.round(node.displayX - fontSize / 2 - 2), Math.round(node.displayY - fontSize / 2 - 2), Math.round(ctx.measureText(node.label).width + 1.5 * node.displaySize + fontSize / 2 + 4), Math.round(fontSize + 4), Math.round(fontSize / 2 + 2), "left"), 
            ctx.closePath(), ctx.fill(), ctx.shadowOffsetX = 0, ctx.shadowOffsetY = 0, ctx.shadowBlur = 0, 
            ctx.beginPath(), ctx.fillStyle = "node" == self.p.nodeBorderColor ? node.color || self.p.defaultNodeColor : self.p.defaultNodeBorderColor, 
            ctx.arc(Math.round(node.displayX), Math.round(node.displayY), node.displaySize + self.p.borderSize, 0, 2 * Math.PI, !0), 
            ctx.closePath(), ctx.fill(), ctx.beginPath(), ctx.fillStyle = "node" == self.p.nodeHoverColor ? node.color || self.p.defaultNodeColor : self.p.defaultNodeHoverColor, 
            ctx.arc(Math.round(node.displayX), Math.round(node.displayY), node.displaySize, 0, 2 * Math.PI, !0), 
            ctx.closePath(), ctx.fill(), ctx.fillStyle = "node" == self.p.labelHoverColor ? node.color || self.p.defaultNodeColor : self.p.defaultLabelHoverColor, 
            ctx.fillText(node.label, Math.round(node.displayX + 1.5 * node.displaySize), Math.round(node.displayY + fontSize / 2 - 3)), 
            self;
        }
        function drawActiveNode(node) {
            var ctx = hoverCtx;
            if (!isOnScreen(node)) return self;
            var fontSize = "fixed" == self.p.labelSize ? self.p.defaultLabelSize : self.p.labelSizeRatio * node.displaySize;
            return ctx.font = (self.p.activeFontStyle || self.p.fontStyle || "") + " " + fontSize + "px " + (self.p.activeFont || self.p.font || ""), 
            ctx.fillStyle = "node" == self.p.labelHoverBGColor ? node.color || self.p.defaultNodeColor : self.p.defaultActiveLabelBGColor, 
            ctx.beginPath(), self.p.labelActiveShadow && (ctx.shadowOffsetX = 0, ctx.shadowOffsetY = 0, 
            ctx.shadowBlur = 4, ctx.shadowColor = self.p.labelActiveShadowColor), sigma.tools.drawRoundRect(ctx, Math.round(node.displayX - fontSize / 2 - 2), Math.round(node.displayY - fontSize / 2 - 2), Math.round(ctx.measureText(node.label).width + 1.5 * node.displaySize + fontSize / 2 + 4), Math.round(fontSize + 4), Math.round(fontSize / 2 + 2), "left"), 
            ctx.closePath(), ctx.fill(), ctx.shadowOffsetX = 0, ctx.shadowOffsetY = 0, ctx.shadowBlur = 0, 
            ctx.beginPath(), ctx.fillStyle = "node" == self.p.nodeBorderColor ? node.color || self.p.defaultNodeColor : self.p.defaultNodeBorderColor, 
            ctx.arc(Math.round(node.displayX), Math.round(node.displayY), node.displaySize + self.p.borderSize, 0, 2 * Math.PI, !0), 
            ctx.closePath(), ctx.fill(), ctx.beginPath(), ctx.fillStyle = "node" == self.p.nodeActiveColor ? node.color || self.p.defaultNodeColor : self.p.defaultNodeActiveColor, 
            ctx.arc(Math.round(node.displayX), Math.round(node.displayY), node.displaySize, 0, 2 * Math.PI, !0), 
            ctx.closePath(), ctx.fill(), ctx.fillStyle = "node" == self.p.labelActiveColor ? node.color || self.p.defaultNodeColor : self.p.defaultLabelActiveColor, 
            ctx.fillText(node.label, Math.round(node.displayX + 1.5 * node.displaySize), Math.round(node.displayY + fontSize / 2 - 3)), 
            self;
        }
        function isOnScreen(node) {
            if (isNaN(node.x) || isNaN(node.y)) throw new Error("A node's coordinate is not a number (id: " + node.id + ")");
            return !node.hidden && node.displayX + node.displaySize > -width / 3 && node.displayX - node.displaySize < 4 * width / 3 && node.displayY + node.displaySize > -height / 3 && node.displayY - node.displaySize < 4 * height / 3;
        }
        function resize(w, h) {
            return width = w, height = h, self;
        }
        sigma.classes.Cascade.call(this);
        var self = this;
        this.p = {
            labelColor: "default",
            defaultLabelColor: "#000",
            labelHoverBGColor: "default",
            defaultHoverLabelBGColor: "#fff",
            labelHoverShadow: !0,
            labelHoverShadowColor: "#000",
            labelHoverColor: "default",
            defaultLabelHoverColor: "#000",
            labelActiveBGColor: "default",
            defaultActiveLabelBGColor: "#fff",
            labelActiveShadow: !0,
            labelActiveShadowColor: "#000",
            labelActiveColor: "default",
            defaultLabelActiveColor: "#000",
            labelSize: "fixed",
            defaultLabelSize: 12,
            labelSizeRatio: 2,
            labelThreshold: 6,
            font: "Arial",
            hoverFont: "",
            activeFont: "",
            fontStyle: "",
            hoverFontStyle: "",
            activeFontStyle: "",
            edgeColor: "source",
            defaultEdgeColor: "#aaa",
            defaultEdgeType: "line",
            defaultNodeColor: "#aaa",
            nodeHoverColor: "node",
            defaultNodeHoverColor: "#fff",
            nodeActiveColor: "node",
            defaultNodeActiveColor: "#fff",
            borderSize: 0,
            nodeBorderColor: "node",
            defaultNodeBorderColor: "#fff",
            edgesSpeed: 200,
            nodesSpeed: 200,
            labelsSpeed: 200
        };
        var nodesCtx = nodesCtx, edgesCtx = edgesCtx, labelsCtx = labelsCtx, hoverCtx = hoverCtx, graph = graph, width = w, height = h;
        this.currentEdgeIndex = 0, this.currentNodeIndex = 0, this.currentLabelIndex = 0, 
        this.task_drawLabel = task_drawLabel, this.task_drawEdge = task_drawEdge, this.task_drawNode = task_drawNode, 
        this.drawActiveNode = drawActiveNode, this.drawHoverNode = drawHoverNode, this.isOnScreen = isOnScreen, 
        this.resize = resize;
    }
    function Sigma(root, id) {
        function resize(w, h) {
            var oldW = self.width, oldH = self.height;
            if (void 0 != w && void 0 != h ? (self.width = w, self.height = h) : (self.width = self.domRoot.offsetWidth, 
            self.height = self.domRoot.offsetHeight), oldW != self.width || oldH != self.height) {
                for (var k in self.domElements) self.domElements[k].setAttribute("width", self.width + "px"), 
                self.domElements[k].setAttribute("height", self.height + "px");
                self.plotter.resize(self.width, self.height), self.draw(self.p.lastNodes, self.p.lastEdges, self.p.lastLabels, !0);
            }
            return self;
        }
        function clearSchedule() {
            return sigma.chronos.removeTask("node_" + self.id, 2).removeTask("edge_" + self.id, 2).removeTask("label_" + self.id, 2).stopTasks(), 
            self;
        }
        function initDOM(id, type) {
            return self.domElements[id] = document.createElement(type), self.domElements[id].style.position = "absolute", 
            self.domElements[id].setAttribute("id", "sigma_" + id + "_" + self.id), self.domElements[id].setAttribute("class", "sigma_" + id + "_" + type), 
            self.domElements[id].setAttribute("width", self.width + "px"), self.domElements[id].setAttribute("height", self.height + "px"), 
            self.domRoot.appendChild(self.domElements[id]), self;
        }
        function draw(nodes, edges, labels, safe) {
            if (safe && sigma.chronos.getGeneratorsIDs().some(function(id) {
                return !!id.match(new RegExp("_ext_" + self.id + "$", ""));
            })) return self;
            var n = void 0 == nodes ? self.p.drawNodes : nodes, e = void 0 == edges ? self.p.drawEdges : edges, l = void 0 == labels ? self.p.drawLabels : labels, params = {
                nodes: n,
                edges: e,
                labels: l
            };
            self.p.lastNodes = n, self.p.lastEdges = e, self.p.lastLabels = l, clearSchedule(), 
            self.graph.rescale(self.width, self.height, n > 0, e > 0).setBorders(), self.mousecaptor.checkBorders(self.graph.borders, self.width, self.height), 
            self.graph.translate(self.mousecaptor.stageX, self.mousecaptor.stageY, self.mousecaptor.ratio, n > 0, e > 0), 
            self.dispatch("graphscaled");
            for (var k in self.domElements) "canvas" == self.domElements[k].nodeName.toLowerCase() && (void 0 == params[k] || params[k] >= 0) && self.domElements[k].getContext("2d").clearRect(0, 0, self.domElements[k].width, self.domElements[k].height);
            self.plotter.currentEdgeIndex = 0, self.plotter.currentNodeIndex = 0, self.plotter.currentLabelIndex = 0;
            var previous = null, start = !1;
            if (n) if (n > 1) for (;self.plotter.task_drawNode(); ) ; else sigma.chronos.addTask(self.plotter.task_drawNode, "node_" + self.id, !1), 
            start = !0, previous = "node_" + self.id;
            if (l) if (l > 1) for (;self.plotter.task_drawLabel(); ) ; else previous ? sigma.chronos.queueTask(self.plotter.task_drawLabel, "label_" + self.id, previous) : sigma.chronos.addTask(self.plotter.task_drawLabel, "label_" + self.id, !1), 
            start = !0, previous = "label_" + self.id;
            if (e) if (e > 1) for (;self.plotter.task_drawEdge(); ) ; else previous ? sigma.chronos.queueTask(self.plotter.task_drawEdge, "edge_" + self.id, previous) : sigma.chronos.addTask(self.plotter.task_drawEdge, "edge_" + self.id, !1), 
            start = !0, previous = "edge_" + self.id;
            return self.dispatch("draw"), self.refresh(), start && sigma.chronos.runTasks(), 
            self;
        }
        function refresh() {
            return self.domElements.hover.getContext("2d").clearRect(0, 0, self.domElements.hover.width, self.domElements.hover.height), 
            drawHover(), drawActive(), self;
        }
        function drawHover() {
            return self.p.drawHoverNodes && (self.graph.checkHover(self.mousecaptor.mouseX, self.mousecaptor.mouseY), 
            self.graph.nodes.forEach(function(node) {
                node.hover && !node.active && self.plotter.drawHoverNode(node);
            })), self;
        }
        function drawActive() {
            return self.p.drawActiveNodes && self.graph.nodes.forEach(function(node) {
                node.active && self.plotter.drawActiveNode(node);
            }), self;
        }
        sigma.classes.Cascade.call(this), sigma.classes.EventDispatcher.call(this);
        var self = this;
        this.id = id.toString(), this.p = {
            auto: !0,
            drawNodes: 2,
            drawEdges: 1,
            drawLabels: 2,
            lastNodes: 2,
            lastEdges: 0,
            lastLabels: 2,
            drawHoverNodes: !0,
            drawActiveNodes: !0
        }, this.domRoot = root, this.width = this.domRoot.offsetWidth, this.height = this.domRoot.offsetHeight, 
        this.graph = new Graph(), this.domElements = {}, initDOM("edges", "canvas"), initDOM("nodes", "canvas"), 
        initDOM("labels", "canvas"), initDOM("hover", "canvas"), initDOM("monitor", "div"), 
        initDOM("mouse", "canvas"), this.plotter = new Plotter(this.domElements.nodes.getContext("2d"), this.domElements.edges.getContext("2d"), this.domElements.labels.getContext("2d"), this.domElements.hover.getContext("2d"), this.graph, this.width, this.height), 
        this.monitor = new Monitor(this, this.domElements.monitor), this.mousecaptor = new MouseCaptor(this.domElements.mouse, this.id), 
        this.mousecaptor.bind("drag interpolate", function() {
            self.draw(self.p.auto ? 2 : self.p.drawNodes, self.p.auto ? 0 : self.p.drawEdges, self.p.auto ? 2 : self.p.drawLabels, !0);
        }).bind("stopdrag stopinterpolate", function() {
            self.draw(self.p.auto ? 2 : self.p.drawNodes, self.p.auto ? 1 : self.p.drawEdges, self.p.auto ? 2 : self.p.drawLabels, !0);
        }).bind("mousedown mouseup", function(e) {
            var targeted = self.graph.nodes.filter(function(n) {
                return !!n.hover;
            }).map(function(n) {
                return n.id;
            });
            self.dispatch("mousedown" == e.type ? "downgraph" : "upgraph"), targeted.length && self.dispatch("mousedown" == e.type ? "downnodes" : "upnodes", targeted);
        }).bind("move", function() {
            self.domElements.hover.getContext("2d").clearRect(0, 0, self.domElements.hover.width, self.domElements.hover.height), 
            drawHover(), drawActive();
        }), sigma.chronos.bind("startgenerators", function() {
            sigma.chronos.getGeneratorsIDs().some(function(id) {
                return !!id.match(new RegExp("_ext_" + self.id + "$", ""));
            }) && self.draw(self.p.auto ? 2 : self.p.drawNodes, self.p.auto ? 0 : self.p.drawEdges, self.p.auto ? 2 : self.p.drawLabels);
        }).bind("stopgenerators", function() {
            self.draw();
        });
        for (var i = 0; i < local.plugins.length; i++) local.plugins[i](this);
        this.draw = draw, this.resize = resize, this.refresh = refresh, this.drawHover = drawHover, 
        this.drawActive = drawActive, this.clearSchedule = clearSchedule, window.addEventListener("resize", function() {
            self.resize();
        });
    }
    function SigmaPublic(sigmaInstance) {
        var s = sigmaInstance, self = this;
        sigma.classes.EventDispatcher.call(this), this._core = sigmaInstance, this.kill = function() {}, 
        this.getID = function() {
            return s.id;
        }, this.configProperties = function(a1, a2) {
            var res = s.config(a1, a2);
            return res == s ? self : res;
        }, this.drawingProperties = function(a1, a2) {
            var res = s.plotter.config(a1, a2);
            return res == s.plotter ? self : res;
        }, this.mouseProperties = function(a1, a2) {
            var res = s.mousecaptor.config(a1, a2);
            return res == s.mousecaptor ? self : res;
        }, this.graphProperties = function(a1, a2) {
            var res = s.graph.config(a1, a2);
            return res == s.graph ? self : res;
        }, this.getMouse = function() {
            return {
                mouseX: s.mousecaptor.mouseX,
                mouseY: s.mousecaptor.mouseY,
                down: s.mousecaptor.isMouseDown
            };
        }, this.position = function(stageX, stageY, ratio) {
            return 0 == arguments.length ? {
                stageX: s.mousecaptor.stageX,
                stageY: s.mousecaptor.stageY,
                ratio: s.mousecaptor.ratio
            } : (s.mousecaptor.stageX = void 0 != stageX ? stageX : s.mousecaptor.stageX, s.mousecaptor.stageY = void 0 != stageY ? stageY : s.mousecaptor.stageY, 
            s.mousecaptor.ratio = void 0 != ratio ? ratio : s.mousecaptor.ratio, self);
        }, this.goTo = function(stageX, stageY, ratio) {
            return s.mousecaptor.interpolate(stageX, stageY, ratio), self;
        }, this.zoomTo = function(x, y, ratio) {
            return ratio = Math.min(Math.max(s.mousecaptor.config("minRatio"), ratio), s.mousecaptor.config("maxRatio")), 
            ratio == s.mousecaptor.ratio ? s.mousecaptor.interpolate(x - s.width / 2 + s.mousecaptor.stageX, y - s.height / 2 + s.mousecaptor.stageY) : s.mousecaptor.interpolate((ratio * x - s.mousecaptor.ratio * s.width / 2) / (ratio - s.mousecaptor.ratio), (ratio * y - s.mousecaptor.ratio * s.height / 2) / (ratio - s.mousecaptor.ratio), ratio), 
            self;
        }, this.resize = function(w, h) {
            return s.resize(w, h), self;
        }, this.draw = function(nodes, edges, labels, safe) {
            return s.draw(nodes, edges, labels, safe), self;
        }, this.refresh = function() {
            return s.refresh(), self;
        }, this.addGenerator = function(id, task, condition) {
            return sigma.chronos.addGenerator(id + "_ext_" + s.id, task, condition), self;
        }, this.removeGenerator = function(id) {
            return sigma.chronos.removeGenerator(id + "_ext_" + s.id), self;
        }, this.addNode = function(id, params) {
            return s.graph.addNode(id, params), self;
        }, this.addEdge = function(id, source, target, params) {
            return s.graph.addEdge(id, source, target, params), self;
        }, this.dropNode = function(v) {
            return s.graph.dropNode(v), self;
        }, this.dropEdge = function(v) {
            return s.graph.dropEdge(v), self;
        }, this.pushGraph = function(object, safe) {
            return object.nodes && object.nodes.forEach(function(node) {
                node.id && (!safe || !s.graph.nodesIndex[node.id]) && self.addNode(node.id, node);
            }), object.edges && object.edges.forEach(function(edge) {
                validID = edge.source && edge.target && edge.id, validID && (!safe || !s.graph.edgesIndex[edge.id]) && self.addNode(edge.id, edge.source, edge.target, edge);
            }), self;
        }, this.emptyGraph = function() {
            return s.graph.empty(), self;
        }, this.getNodesCount = function() {
            return s.graph.nodes.length;
        }, this.getEdgesCount = function() {
            return s.graph.edges.length;
        }, this.iterNodes = function(fun, ids) {
            return s.graph.iterNodes(fun, ids), self;
        }, this.iterEdges = function(fun, ids) {
            return s.graph.iterEdges(fun, ids), self;
        }, this.getNodes = function(ids) {
            return s.graph.getNodes(ids);
        }, this.getEdges = function(ids) {
            return s.graph.getEdges(ids);
        }, this.activateMonitoring = function() {
            return s.monitor.activate();
        }, this.desactivateMonitoring = function() {
            return s.monitor.desactivate();
        }, s.bind("downnodes upnodes downgraph upgraph", function(e) {
            self.dispatch(e.type, e.content);
        }), s.graph.bind("overnodes outnodes", function(e) {
            self.dispatch(e.type, e.content);
        });
    }
    var id = 0, local = {};
    local.plugins = [], sigma.init = function(dom) {
        var inst = new Sigma(dom, (++id).toString());
        return sigma.instances[id] = new SigmaPublic(inst), sigma.instances[id];
    }, sigma.addPlugin = function(pluginName, caller, launcher) {
        SigmaPublic.prototype[pluginName] = caller, local.plugins.push(launcher);
    }, sigma.chronos = new function() {
        function insertFrame(callback) {
            return window.setTimeout(callback, 0), self;
        }
        function frameInserter() {
            for (self.dispatch("frameinserted"); isRunning && tasks.length && routine(); ) ;
            isRunning && tasks.length ? (startTime = new Date().getTime(), framesCount++, delay = effectiveTime - frameTime, 
            correctedFrameTime = frameTime - delay, self.dispatch("insertframe"), insertFrame(frameInserter)) : stopTasks();
        }
        function routine() {
            if (taskIndex %= tasks.length, !tasks[taskIndex].task()) {
                var n = tasks[taskIndex].taskName;
                queuedTasks = queuedTasks.filter(function(e) {
                    return e.taskParent == n && tasks.push({
                        taskName: e.taskName,
                        task: e.task
                    }), e.taskParent != n;
                }), self.dispatch("killed", tasks.splice(taskIndex--, 1)[0]);
            }
            return taskIndex++, effectiveTime = new Date().getTime() - startTime, correctedFrameTime >= effectiveTime;
        }
        function runTasks() {
            return isRunning = !0, taskIndex = 0, framesCount = 0, startTime = new Date().getTime(), 
            currentTime = startTime, self.dispatch("start"), self.dispatch("insertframe"), insertFrame(frameInserter), 
            self;
        }
        function stopTasks() {
            return self.dispatch("stop"), isRunning = !1, self;
        }
        function addTask(task, name, autostart) {
            if ("function" != typeof task) throw new Error('Task "' + name + '" is not a function');
            return tasks.push({
                taskName: name,
                task: task
            }), isRunning = !0, self;
        }
        function queueTask(task, name, parent) {
            if ("function" != typeof task) throw new Error('Task "' + name + '" is not a function');
            if (!tasks.concat(queuedTasks).some(function(e) {
                return e.taskName == parent;
            })) throw new Error('Parent task "' + parent + '" of "' + name + '" is not attached.');
            return queuedTasks.push({
                taskParent: parent,
                taskName: name,
                task: task
            }), self;
        }
        function removeTask(v, queueStatus) {
            if (void 0 == v) tasks = [], 1 == queueStatus ? queuedTasks = [] : 2 == queueStatus && (tasks = queuedTasks, 
            queuedTasks = []), stopTasks(); else {
                var n = "string" == typeof v ? v : "";
                tasks = tasks.filter(function(e) {
                    return ("string" == typeof v ? e.taskName == v : e.task == v) ? (n = e.taskName, 
                    !1) : !0;
                }), queueStatus > 0 && (queuedTasks = queuedTasks.filter(function(e) {
                    return 1 == queueStatus && e.taskParent == n && tasks.push(e), e.taskParent != n;
                }));
            }
            return isRunning = !tasks.length, self;
        }
        function addGenerator(id, task, condition) {
            return void 0 != generators[id] ? self : (generators[id] = {
                task: task,
                condition: condition
            }, 0 == getGeneratorsCount(!0) && startGenerators(), self);
        }
        function removeGenerator(id) {
            return generators[id] && (generators[id].on = !1, generators[id].del = !0), self;
        }
        function getGeneratorsCount(running) {
            return running ? Object.keys(generators).filter(function(id) {
                return !!generators[id].on;
            }).length : Object.keys(generators).length;
        }
        function getGeneratorsIDs() {
            return Object.keys(generators);
        }
        function startGenerators() {
            return Object.keys(generators).length ? (self.dispatch("startgenerators"), self.unbind("killed", onTaskEnded), 
            insertFrame(function() {
                for (var k in generators) generators[k].on = !0, addTask(generators[k].task, k, !1);
            }), self.bind("killed", onTaskEnded).runTasks()) : self.dispatch("stopgenerators"), 
            self;
        }
        function onTaskEnded(e) {
            void 0 != generators[e.content.taskName] && (generators[e.content.taskName].del || !generators[e.content.taskName].condition() ? delete generators[e.content.taskName] : generators[e.content.taskName].on = !1, 
            0 == getGeneratorsCount(!0) && startGenerators());
        }
        function frequency(v) {
            return void 0 != v ? (fpsReq = Math.abs(1 * v), frameTime = 1e3 / fpsReq, framesCount = 0, 
            self) : fpsReq;
        }
        function getFPS() {
            return isRunning && (lastFPS = Math.round(1e4 * (framesCount / (new Date().getTime() - currentTime))) / 10), 
            lastFPS;
        }
        function getTasksCount() {
            return tasks.length;
        }
        function getQueuedTasksCount() {
            return queuedTasks.length;
        }
        function getExecutionTime() {
            return startTime - currentTime;
        }
        sigma.classes.EventDispatcher.call(this);
        var self = this, isRunning = !1, fpsReq = 80, lastFPS = 0, framesCount = 0, frameTime = 1e3 / fpsReq, correctedFrameTime = frameTime, effectiveTime = 0, currentTime = 0, startTime = 0, delay = 0, generators = {}, tasks = [], queuedTasks = [], taskIndex = 0;
        return this.frequency = frequency, this.runTasks = runTasks, this.stopTasks = stopTasks, 
        this.insertFrame = insertFrame, this.addTask = addTask, this.queueTask = queueTask, 
        this.removeTask = removeTask, this.addGenerator = addGenerator, this.removeGenerator = removeGenerator, 
        this.startGenerators = startGenerators, this.getGeneratorsIDs = getGeneratorsIDs, 
        this.getFPS = getFPS, this.getTasksCount = getTasksCount, this.getQueuedTasksCount = getQueuedTasksCount, 
        this.getExecutionTime = getExecutionTime, this;
    }(), sigma.debugMode = 0, sigma.log = function() {
        if (1 == sigma.debugMode) for (var k in arguments) console.log(arguments[k]); else if (sigma.debugMode > 1) for (var k in arguments) throw new Error(arguments[k]);
        return sigma;
    }, sigma.easing = {
        linear: {},
        quadratic: {}
    }, sigma.easing.linear.easenone = function(k) {
        return k;
    }, sigma.easing.quadratic.easein = function(k) {
        return k * k;
    }, sigma.easing.quadratic.easeout = function(k) {
        return -k * (k - 2);
    }, sigma.easing.quadratic.easeinout = function(k) {
        return (k *= 2) < 1 ? .5 * k * k : -.5 * (--k * (k - 2) - 1);
    }, sigma.tools.drawRoundRect = function(ctx, x, y, w, h, ellipse, corners) {
        var e = ellipse ? ellipse : 0, c = corners ? corners : [];
        c = "string" == typeof c ? c.split(" ") : c;
        var tl = e && (c.indexOf("topleft") >= 0 || c.indexOf("top") >= 0 || c.indexOf("left") >= 0), tr = e && (c.indexOf("topright") >= 0 || c.indexOf("top") >= 0 || c.indexOf("right") >= 0), bl = e && (c.indexOf("bottomleft") >= 0 || c.indexOf("bottom") >= 0 || c.indexOf("left") >= 0), br = e && (c.indexOf("bottomright") >= 0 || c.indexOf("bottom") >= 0 || c.indexOf("right") >= 0);
        ctx.moveTo(x, y + e), tl ? ctx.arcTo(x, y, x + e, y, e) : ctx.lineTo(x, y), tr ? (ctx.lineTo(x + w - e, y), 
        ctx.arcTo(x + w, y, x + w, y + e, e)) : ctx.lineTo(x + w, y), br ? (ctx.lineTo(x + w, y + h - e), 
        ctx.arcTo(x + w, y + h, x + w - e, y + h, e)) : ctx.lineTo(x + w, y + h), bl ? (ctx.lineTo(x + e, y + h), 
        ctx.arcTo(x, y + h, x, y + h - e, e)) : ctx.lineTo(x, y + h), ctx.lineTo(x, y + e);
    }, sigma.tools.getRGB = function(s, asArray) {
        s = s.toString();
        var res = {
            r: 0,
            g: 0,
            b: 0
        };
        if (s.length >= 3 && "#" == s.charAt(0)) {
            var l = s.length - 1;
            6 == l ? res = {
                r: parseInt(s.charAt(1) + s.charAt(2), 16),
                g: parseInt(s.charAt(3) + s.charAt(4), 16),
                b: parseInt(s.charAt(5) + s.charAt(5), 16)
            } : 3 == l && (res = {
                r: parseInt(s.charAt(1) + s.charAt(1), 16),
                g: parseInt(s.charAt(2) + s.charAt(2), 16),
                b: parseInt(s.charAt(3) + s.charAt(3), 16)
            });
        }
        return asArray && (res = [ res.r, res.g, res.b ]), res;
    }, sigma.tools.rgbToHex = function(R, G, B) {
        return sigma.tools.toHex(R) + sigma.tools.toHex(G) + sigma.tools.toHex(B);
    }, sigma.tools.toHex = function(n) {
        return n = parseInt(n, 10), isNaN(n) ? "00" : (n = Math.max(0, Math.min(n, 255)), 
        "0123456789ABCDEF".charAt((n - n % 16) / 16) + "0123456789ABCDEF".charAt(n % 16));
    }, sigma.publicPrototype = SigmaPublic.prototype;
}();

var awsSecurityGroupsApp = angular.module("awsSecurityGroupsApp", []);

awsSecurityGroupsApp.directive("sigma", function() {
    return {
        template: "<div></div>",
        restrict: "A",
        link: function(scope, element) {
            var sigInst = sigma.init(element[0]);
            sigInst.addNode("hello", {
                label: "Hello",
                color: "#ff0000"
            }).addNode("world", {
                label: "World !",
                color: "#00ff00"
            }).addEdge("hello_world", "hello", "world").draw();
        }
    };
});